(function() {
  var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  };
  exports.Actor = function() {
    function _Class() {
      _Class.__super__.constructor.apply(this, arguments);
    }
    __extends(_Class, require('../actor').Actor);
    _Class.build = function(freakset, scope, opts, fn) {
      var innerFreakset, _ref;
      _ref = this.prototype.ensureArgs.apply(this, arguments), freakset = _ref[0], scope = _ref[1], opts = _ref[2], fn = _ref[3];
      if (typeof opts === "function") {
        fn = opts;
        opts = void 0;
      }
      opts || (opts = {});
      opts.parallel || (opts.parallel = false);
      innerFreakset = freakset.klass.build({
        store: freakset.store,
        outerFreakset: freakset,
        runInParallel: opts.parallel
      });
      freakset.modifyStack(freakset, {
        type: "group",
        scope: scope,
        fn: fn,
        innerFreakset: innerFreakset,
        parallel: opts.parallel
      }, opts);
      freakset.innerFreaksets.push(innerFreakset);
      fn(innerFreakset);
      return innerFreakset;
    };
    _Class.run = function(freakset, actor) {
      return freakset.buildAndRunFreakset({
        stack: actor.innerFreakset.stack,
        store: freakset.store,
        outerFreakset: freakset,
        runInParallel: actor.parallel
      });
    };
    return _Class;
  }();
}).call(this);
