require '../../../spec_helper'

describe "Freakset.Actor", ->

  beforeEach ->
    @actor = new Freakset.Actor()

  describe '#ensureArgs', ->
    it 'should return the passed arguments', ->
      expect(@actor.ensureArgs("a", "b")).toEqual(["a", "b"])

    it 'should insert a empty scope if the passed scope is empty', ->
      expect(@actor.ensureArgs(1,2,3)).toEqual([1, "", 2, 3])
