(function() {
  var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  };
  exports.Actor = (function() {
    function _Class() {
      _Class.__super__.constructor.apply(this, arguments);
    }
    __extends(_Class, require('../actor').Actor);
    _Class.build = function(freakset, scope, opts, fn) {
      var _ref;
      _ref = this.prototype.ensureArgs.apply(this, arguments), freakset = _ref[0], scope = _ref[1], opts = _ref[2], fn = _ref[3];
      if (typeof opts === "function") {
        fn = opts;
        opts = void 0;
      }
      if (freakset.runInParallel != null) {
        freakset.parallelStepCount || (freakset.parallelStepCount = 0);
        freakset.parallelStepCount += 1;
      }
      return freakset.modifyStack(freakset, {
        type: "step",
        scope: scope,
        fn: fn
      }, opts);
    };
    _Class.run = function(freakset, actor) {
      actor.fn(freakset);
      if (freakset.runInParallel != null) {
        return freakset.next();
      }
    };
    return _Class;
  })();
}).call(this);
